diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index 34ca6d4ac2..d424450e7b 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -1465,7 +1597,8 @@ create_merge_append_plan(PlannerInfo *root, MergeAppendPath *best_path,
 	 * function result; it must be the same plan node.  However, we then need
 	 * to detect whether any tlist entries were added.
 	 */
-	(void) prepare_sort_from_pathkeys(plan, pathkeys,
+	(void) prepare_sort_from_pathkeys(context,
+									  plan, pathkeys,
 									  best_path->path.parent->relids,
 									  NULL,
 									  true,
@@ -1493,10 +1626,11 @@ create_merge_append_plan(PlannerInfo *root, MergeAppendPath *best_path,
 
 		/* Build the child plan */
 		/* Must insist that all children return the same tlist */
-		subplan = create_plan_recurse(root, subpath, CP_EXACT_TLIST);
+		subplan = create_plan_recurse(context, root, subpath, CP_EXACT_TLIST);
 
 		/* Compute sort column info, and adjust subplan's tlist as needed */
-		subplan = prepare_sort_from_pathkeys(subplan, pathkeys,
+		subplan = prepare_sort_from_pathkeys(context,
+											 subplan, pathkeys,
 											 subpath->parent->relids,
 											 node->sortColIdx,
 											 false,
@@ -1568,7 +1702,7 @@ create_merge_append_plan(PlannerInfo *root, MergeAppendPath *best_path,
 	if (tlist_was_changed && (flags & (CP_EXACT_TLIST | CP_SMALL_TLIST)))
 	{
 		tlist = list_copy_head(plan->targetlist, orig_tlist_length);
-		return inject_projection_plan(plan, tlist, plan->parallel_safe);
+		return inject_projection_plan(context, plan, tlist, plan->parallel_safe);
 	}
 	else
 		return plan;
@@ -1582,7 +1716,8 @@ create_merge_append_plan(PlannerInfo *root, MergeAppendPath *best_path,
  *	  Returns a Plan node.
  */
 static Result *
-create_group_result_plan(PlannerInfo *root, GroupResultPath *best_path)
+create_group_result_plan(CreatePlanContext *context, PlannerInfo *root,
+						 GroupResultPath *best_path)
 {
 	Result	   *plan;
 	List	   *tlist;
@@ -1607,14 +1742,15 @@ create_group_result_plan(PlannerInfo *root, GroupResultPath *best_path)
  *	  Returns a Plan node.
  */
 static ProjectSet *
-create_project_set_plan(PlannerInfo *root, ProjectSetPath *best_path)
+create_project_set_plan(CreatePlanContext *context, PlannerInfo *root,
+						ProjectSetPath *best_path)
 {
 	ProjectSet *plan;
 	Plan	   *subplan;
 	List	   *tlist;
 
 	/* Since we intend to project, we don't need to constrain child tlist */
-	subplan = create_plan_recurse(root, best_path->subpath, 0);
+	subplan = create_plan_recurse(context, root, best_path->subpath, 0);
 
 	tlist = build_path_tlist(root, &best_path->path);
 
@@ -1633,7 +1769,8 @@ create_project_set_plan(PlannerInfo *root, ProjectSetPath *best_path)
  *	  Returns a Plan node.
  */
 static Material *
-create_material_plan(PlannerInfo *root, MaterialPath *best_path, int flags)
+create_material_plan(CreatePlanContext *context, PlannerInfo *root,
+					 MaterialPath *best_path, int flags)
 {
 	Material   *plan;
 	Plan	   *subplan;
@@ -1643,7 +1780,7 @@ create_material_plan(PlannerInfo *root, MaterialPath *best_path, int flags)
 	 * a smaller tlist.  Otherwise, since Material doesn't project, tlist
 	 * requirements pass through.
 	 */
-	subplan = create_plan_recurse(root, best_path->subpath,
+	subplan = create_plan_recurse(context, root, best_path->subpath,
 								  flags | CP_SMALL_TLIST);
 
 	plan = make_material(subplan);
@@ -1661,20 +1798,28 @@ create_material_plan(PlannerInfo *root, MaterialPath *best_path, int flags)
  *	  Returns a Plan node.
  */
 static Memoize *
-create_memoize_plan(PlannerInfo *root, MemoizePath *best_path, int flags)
+create_memoize_plan(CreatePlanContext *context, PlannerInfo *root,
+					MemoizePath *best_path, int flags)
 {
-	Memoize    *plan;
-	Bitmapset  *keyparamids;
-	Plan	   *subplan;
-	Oid		   *operators;
-	Oid		   *collations;
-	List	   *param_exprs = NIL;
-	ListCell   *lc;
-	ListCell   *lc2;
-	int			nkeys;
-	int			i;
+	CreatePlanContext subplan_context;
+	Memoize    		  *plan;
+	Bitmapset  		  *keyparamids;
+	Plan	   		  *subplan;
+	Oid		   		  *operators;
+	Oid		   		  *collations;
+	List	   		  *param_exprs = NIL;
+	ListCell   		  *lc;
+	ListCell   		  *lc2;
+	int				   nkeys;
+	int				   i;
 
-	subplan = create_plan_recurse(root, best_path->subpath,
+	/*
+	 * subplan will only be called when it's a cache miss, we need a context 
+	 * with est_calls that takes only cache misses into account. 
+	 */
+	copy_create_plan_context(&subplan_context, context);
+	subplan_context.est_calls = context->est_calls * (1.0 - best_path->est_hitratio);
+	subplan = create_plan_recurse(&subplan_context, root, best_path->subpath,
 								  flags | CP_SMALL_TLIST);
 
 	param_exprs = (List *) replace_nestloop_params(root, (Node *)
@@ -1703,6 +1848,7 @@ create_memoize_plan(PlannerInfo *root, MemoizePath *best_path, int flags)
 						best_path->est_entries, keyparamids);
 
 	copy_generic_path_info(&plan->plan, (Path *) best_path);
+	plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	return plan;
 }
@@ -1715,7 +1861,8 @@ create_memoize_plan(PlannerInfo *root, MemoizePath *best_path, int flags)
  *	  Returns a Plan node.
  */
 static Plan *
-create_unique_plan(PlannerInfo *root, UniquePath *best_path, int flags)
+create_unique_plan(CreatePlanContext *context, PlannerInfo *root,
+				   UniquePath *best_path, int flags)
 {
 	Plan	   *plan;
 	Plan	   *subplan;
@@ -1731,7 +1878,7 @@ create_unique_plan(PlannerInfo *root, UniquePath *best_path, int flags)
 	ListCell   *l;
 
 	/* Unique doesn't project, so tlist requirements pass through */
-	subplan = create_plan_recurse(root, best_path->subpath, flags);
+	subplan = create_plan_recurse(context, root, best_path->subpath, flags);
 
 	/* Done if we don't need to do any actual unique-ifying */
 	if (best_path->umethod == UNIQUE_PATH_NOOP)
@@ -1781,7 +1928,7 @@ create_unique_plan(PlannerInfo *root, UniquePath *best_path, int flags)
 
 	/* Use change_plan_targetlist in case we need to insert a Result node */
 	if (newitems || best_path->umethod == UNIQUE_PATH_SORT)
-		subplan = change_plan_targetlist(subplan, newtlist,
+		subplan = change_plan_targetlist(context, subplan, newtlist,
 										 best_path->path.parallel_safe);
 
 	/*
@@ -1903,6 +2050,7 @@ create_unique_plan(PlannerInfo *root, UniquePath *best_path, int flags)
 
 	/* Copy cost data from Path to Plan */
 	copy_generic_path_info(plan, &best_path->path);
+	plan->est_calls = clamp_row_est(context->est_calls);
 
 	return plan;
 }
@@ -1914,19 +2062,31 @@ create_unique_plan(PlannerInfo *root, UniquePath *best_path, int flags)
  *	  for its subpaths.
  */
 static Gather *
-create_gather_plan(PlannerInfo *root, GatherPath *best_path)
+create_gather_plan(CreatePlanContext *context, PlannerInfo *root,
+				   GatherPath *best_path)
 {
-	Gather	   *gather_plan;
-	Plan	   *subplan;
-	List	   *tlist;
+	CreatePlanContext subplan_context;
+	Gather			  *gather_plan;
+	Plan			  *subplan;
+	List			  *tlist;
 
 	/*
 	 * Push projection down to the child node.  That way, the projection work
 	 * is parallelized, and there can be no system columns in the result (they
 	 * can't travel through a tuple queue because it uses MinimalTuple
 	 * representation).
+	 * 
+	 * XXX: Should we really increase est_calls here? The cost is divided by
+	 * number of workers (see cost_seqscan()). This will reduce the cost for
+	 * nodes above. Multiplying est_calls by number of workers will increase
+	 * the change of JITing. OTOH each worker node JIT compile the expression
+	 * by itself. Increasing est_calls will increase the cost per worker, and
+	 * this increase will make the cost per worker greater than the actual cost
+	 * per worker.
 	 */
-	subplan = create_plan_recurse(root, best_path->subpath, CP_EXACT_TLIST);
+	copy_create_plan_context(&subplan_context, context);
+	subplan_context.est_calls = context->est_calls * best_path->num_workers;
+	subplan = create_plan_recurse(&subplan_context, root, best_path->subpath, CP_EXACT_TLIST);
 
 	tlist = build_path_tlist(root, &best_path->path);
 
@@ -1938,6 +2098,7 @@ create_gather_plan(PlannerInfo *root, GatherPath *best_path)
 							  subplan);
 
 	copy_generic_path_info(&gather_plan->plan, &best_path->path);
+	gather_plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	/* use parallel mode for parallel plans. */
 	root->glob->parallelModeNeeded = true;
@@ -1952,21 +2113,36 @@ create_gather_plan(PlannerInfo *root, GatherPath *best_path)
  *	  plans for its subpaths.
  */
 static GatherMerge *
-create_gather_merge_plan(PlannerInfo *root, GatherMergePath *best_path)
+create_gather_merge_plan(CreatePlanContext *context, PlannerInfo *root,
+						 GatherMergePath *best_path)
 {
-	GatherMerge *gm_plan;
-	Plan	   *subplan;
-	List	   *pathkeys = best_path->path.pathkeys;
-	List	   *tlist = build_path_tlist(root, &best_path->path);
-
-	/* As with Gather, project away columns in the workers. */
-	subplan = create_plan_recurse(root, best_path->subpath, CP_EXACT_TLIST);
+	CreatePlanContext	subplan_context;
+	GatherMerge			*gm_plan;
+	Plan				*subplan;
+	List				*pathkeys = best_path->path.pathkeys;
+	List				*tlist = build_path_tlist(root, &best_path->path);
+
+	/* 
+	 * As with Gather, project away columns in the workers.
+	 *
+	 * XXX: Should we really increase est_calls here? The cost is divided by
+	 * number of workers (see cost_seqscan()). This will reduce the cost for
+	 * nodes above. Multiplying est_calls by number of workers will increase
+	 * the change of JITing. OTOH each worker node JIT compile the expression
+	 * by itself. Increasing est_calls will increase the cost per worker, and
+	 * this increase will make the cost per worker greater than the actual cost
+	 * per worker.
+	 */
+	copy_create_plan_context(&subplan_context, context);
+	subplan_context.est_calls = context->est_calls * best_path->num_workers;
+	subplan = create_plan_recurse(&subplan_context, root, best_path->subpath, CP_EXACT_TLIST);
 
 	/* Create a shell for a GatherMerge plan. */
 	gm_plan = makeNode(GatherMerge);
 	gm_plan->plan.targetlist = tlist;
 	gm_plan->num_workers = best_path->num_workers;
 	copy_generic_path_info(&gm_plan->plan, &best_path->path);
+	gm_plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	/* Assign the rescan Param. */
 	gm_plan->rescan_param = assign_special_exec_param(root);
@@ -1975,7 +2151,8 @@ create_gather_merge_plan(PlannerInfo *root, GatherMergePath *best_path)
 	Assert(pathkeys != NIL);
 
 	/* Compute sort column info, and adjust subplan's tlist as needed */
-	subplan = prepare_sort_from_pathkeys(subplan, pathkeys,
+	subplan = prepare_sort_from_pathkeys(context,
+										 subplan, pathkeys,
 										 best_path->subpath->parent->relids,
 										 gm_plan->sortColIdx,
 										 false,
@@ -2013,7 +2190,8 @@ create_gather_merge_plan(PlannerInfo *root, GatherMergePath *best_path)
  *	  but sometimes we can just let the subplan do the work.
  */
 static Plan *
-create_projection_plan(PlannerInfo *root, ProjectionPath *best_path, int flags)
+create_projection_plan(CreatePlanContext *context, PlannerInfo *root,
+					   ProjectionPath *best_path, int flags)
 {
 	Plan	   *plan;
 	Plan	   *subplan;
@@ -2040,7 +2218,7 @@ create_projection_plan(PlannerInfo *root, ProjectionPath *best_path, int flags)
 		 * actually need to project.  However, we may still need to ensure
 		 * proper sortgroupref labels, if the caller cares about those.
 		 */
-		subplan = create_plan_recurse(root, best_path->subpath, 0);
+		subplan = create_plan_recurse(context, root, best_path->subpath, 0);
 		tlist = subplan->targetlist;
 		if (flags & CP_LABEL_TLIST)
 			apply_pathtarget_labeling_to_tlist(tlist,
@@ -2054,7 +2232,7 @@ create_projection_plan(PlannerInfo *root, ProjectionPath *best_path, int flags)
 		 * Tell create_plan_recurse that we're going to ignore the tlist it
 		 * produces.
 		 */
-		subplan = create_plan_recurse(root, best_path->subpath,
+		subplan = create_plan_recurse(context, root, best_path->subpath,
 									  CP_IGNORE_TLIST);
 		Assert(is_projection_capable_plan(subplan));
 		tlist = build_path_tlist(root, &best_path->path);
@@ -2065,7 +2243,7 @@ create_projection_plan(PlannerInfo *root, ProjectionPath *best_path, int flags)
 		 * It looks like we need a result node, unless by good fortune the
 		 * requested tlist is exactly the one the child wants to produce.
 		 */
-		subplan = create_plan_recurse(root, best_path->subpath, 0);
+		subplan = create_plan_recurse(context, root, best_path->subpath, 0);
 		tlist = build_path_tlist(root, &best_path->path);
 		needs_result_node = !tlist_same_exprs(tlist, subplan->targetlist);
 	}
@@ -2098,6 +2276,7 @@ create_projection_plan(PlannerInfo *root, ProjectionPath *best_path, int flags)
 		plan = (Plan *) make_result(tlist, NULL, subplan);
 
 		copy_generic_path_info(plan, (Path *) best_path);
+		plan->est_calls = clamp_row_est(context->est_calls);
 	}
 
 	return plan;
@@ -2115,7 +2294,8 @@ create_projection_plan(PlannerInfo *root, ProjectionPath *best_path, int flags)
  * to apply (since the tlist might be unsafe even if the child plan is safe).
  */
 static Plan *
-inject_projection_plan(Plan *subplan, List *tlist, bool parallel_safe)
+inject_projection_plan(CreatePlanContext *context, Plan *subplan, List *tlist,
+					   bool parallel_safe)
 {
 	Plan	   *plan;
 
@@ -2129,6 +2309,7 @@ inject_projection_plan(Plan *subplan, List *tlist, bool parallel_safe)
 	 * consistent not more so.  Hence, just copy the subplan's cost.
 	 */
 	copy_plan_costsize(plan, subplan);
+	plan->est_calls = clamp_row_est(context->est_calls);
 	plan->parallel_safe = parallel_safe;
 
 	return plan;
@@ -2147,7 +2328,8 @@ inject_projection_plan(Plan *subplan, List *tlist, bool parallel_safe)
  * flag of the FDW's own Path node.
  */
 Plan *
-change_plan_targetlist(Plan *subplan, List *tlist, bool tlist_parallel_safe)
+change_plan_targetlist(CreatePlanContext *context, Plan *subplan, List *tlist,
+					   bool tlist_parallel_safe)
 {
 	/*
 	 * If the top plan node can't do projections and its existing target list
@@ -2156,7 +2338,7 @@ change_plan_targetlist(Plan *subplan, List *tlist, bool tlist_parallel_safe)
 	 */
 	if (!is_projection_capable_plan(subplan) &&
 		!tlist_same_exprs(tlist, subplan->targetlist))
-		subplan = inject_projection_plan(subplan, tlist,
+		subplan = inject_projection_plan(context, subplan, tlist,
 										 subplan->parallel_safe &&
 										 tlist_parallel_safe);
 	else
@@ -2175,7 +2357,8 @@ change_plan_targetlist(Plan *subplan, List *tlist, bool tlist_parallel_safe)
  *	  for its subpaths.
  */
 static Sort *
-create_sort_plan(PlannerInfo *root, SortPath *best_path, int flags)
+create_sort_plan(CreatePlanContext *context, PlannerInfo *root,
+				 SortPath *best_path, int flags)
 {
 	Sort	   *plan;
 	Plan	   *subplan;
@@ -2185,7 +2368,7 @@ create_sort_plan(PlannerInfo *root, SortPath *best_path, int flags)
 	 * smaller tlist.  Otherwise, since Sort doesn't project, tlist
 	 * requirements pass through.
 	 */
-	subplan = create_plan_recurse(root, best_path->subpath,
+	subplan = create_plan_recurse(context, root, best_path->subpath,
 								  flags | CP_SMALL_TLIST);
 
 	/*
@@ -2194,11 +2377,12 @@ create_sort_plan(PlannerInfo *root, SortPath *best_path, int flags)
 	 * relids. Thus, if this sort path is based on a child relation, we must
 	 * pass its relids.
 	 */
-	plan = make_sort_from_pathkeys(subplan, best_path->path.pathkeys,
+	plan = make_sort_from_pathkeys(context, subplan, best_path->path.pathkeys,
 								   IS_OTHER_REL(best_path->subpath->parent) ?
 								   best_path->path.parent->relids : NULL);
 
 	copy_generic_path_info(&plan->plan, (Path *) best_path);
+	plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	return plan;
 }
@@ -2209,22 +2393,24 @@ create_sort_plan(PlannerInfo *root, SortPath *best_path, int flags)
  *	  Do the same as create_sort_plan, but create IncrementalSort plan.
  */
 static IncrementalSort *
-create_incrementalsort_plan(PlannerInfo *root, IncrementalSortPath *best_path,
-							int flags)
+create_incrementalsort_plan(CreatePlanContext *context, PlannerInfo *root,
+							IncrementalSortPath *best_path, int flags)
 {
 	IncrementalSort *plan;
 	Plan	   *subplan;
 
 	/* See comments in create_sort_plan() above */
-	subplan = create_plan_recurse(root, best_path->spath.subpath,
+	subplan = create_plan_recurse(context, root, best_path->spath.subpath,
 								  flags | CP_SMALL_TLIST);
-	plan = make_incrementalsort_from_pathkeys(subplan,
+	plan = make_incrementalsort_from_pathkeys(context,
+											  subplan,
 											  best_path->spath.path.pathkeys,
 											  IS_OTHER_REL(best_path->spath.subpath->parent) ?
 											  best_path->spath.path.parent->relids : NULL,
 											  best_path->nPresortedCols);
 
 	copy_generic_path_info(&plan->sort.plan, (Path *) best_path);
+	plan->sort.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return plan;
 }
@@ -2236,7 +2422,8 @@ create_incrementalsort_plan(PlannerInfo *root, IncrementalSortPath *best_path,
  *	  for its subpaths.
  */
 static Group *
-create_group_plan(PlannerInfo *root, GroupPath *best_path)
+create_group_plan(CreatePlanContext *context, PlannerInfo *root,
+				  GroupPath *best_path)
 {
 	Group	   *plan;
 	Plan	   *subplan;
@@ -2247,7 +2434,7 @@ create_group_plan(PlannerInfo *root, GroupPath *best_path)
 	 * Group can project, so no need to be terribly picky about child tlist,
 	 * but we do need grouping columns to be available
 	 */
-	subplan = create_plan_recurse(root, best_path->subpath, CP_LABEL_TLIST);
+	subplan = create_plan_recurse(context, root, best_path->subpath, CP_LABEL_TLIST);
 
 	tlist = build_path_tlist(root, &best_path->path);
 
@@ -2264,6 +2451,7 @@ create_group_plan(PlannerInfo *root, GroupPath *best_path)
 					  subplan);
 
 	copy_generic_path_info(&plan->plan, (Path *) best_path);
+	plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	return plan;
 }
@@ -2275,7 +2463,8 @@ create_group_plan(PlannerInfo *root, GroupPath *best_path)
  *	  for its subpaths.
  */
 static Unique *
-create_upper_unique_plan(PlannerInfo *root, UpperUniquePath *best_path, int flags)
+create_upper_unique_plan(CreatePlanContext *context, PlannerInfo *root,
+						 UpperUniquePath *best_path, int flags)
 {
 	Unique	   *plan;
 	Plan	   *subplan;
@@ -2284,7 +2473,7 @@ create_upper_unique_plan(PlannerInfo *root, UpperUniquePath *best_path, int flag
 	 * Unique doesn't project, so tlist requirements pass through; moreover we
 	 * need grouping columns to be labeled.
 	 */
-	subplan = create_plan_recurse(root, best_path->subpath,
+	subplan = create_plan_recurse(context, root, best_path->subpath,
 								  flags | CP_LABEL_TLIST);
 
 	plan = make_unique_from_pathkeys(subplan,
@@ -2292,6 +2481,7 @@ create_upper_unique_plan(PlannerInfo *root, UpperUniquePath *best_path, int flag
 									 best_path->numkeys);
 
 	copy_generic_path_info(&plan->plan, (Path *) best_path);
+	plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	return plan;
 }
@@ -2303,7 +2493,7 @@ create_upper_unique_plan(PlannerInfo *root, UpperUniquePath *best_path, int flag
  *	  for its subpaths.
  */
 static Agg *
-create_agg_plan(PlannerInfo *root, AggPath *best_path)
+create_agg_plan(CreatePlanContext *context, PlannerInfo *root, AggPath *best_path)
 {
 	Agg		   *plan;
 	Plan	   *subplan;
@@ -2314,7 +2504,7 @@ create_agg_plan(PlannerInfo *root, AggPath *best_path)
 	 * Agg can project, so no need to be terribly picky about child tlist, but
 	 * we do need grouping columns to be available
 	 */
-	subplan = create_plan_recurse(root, best_path->subpath, CP_LABEL_TLIST);
+	subplan = create_plan_recurse(context, root, best_path->subpath, CP_LABEL_TLIST);
 
 	tlist = build_path_tlist(root, &best_path->path);
 
@@ -2336,6 +2526,7 @@ create_agg_plan(PlannerInfo *root, AggPath *best_path)
 					subplan);
 
 	copy_generic_path_info(&plan->plan, (Path *) best_path);
+	plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	return plan;
 }
@@ -2387,7 +2578,8 @@ remap_groupColIdx(PlannerInfo *root, List *groupClause)
  *	  Returns a Plan node.
  */
 static Plan *
-create_groupingsets_plan(PlannerInfo *root, GroupingSetsPath *best_path)
+create_groupingsets_plan(CreatePlanContext *context, PlannerInfo *root,
+						 GroupingSetsPath *best_path)
 {
 	Agg		   *plan;
 	Plan	   *subplan;
@@ -2405,7 +2597,7 @@ create_groupingsets_plan(PlannerInfo *root, GroupingSetsPath *best_path)
 	 * Agg can project, so no need to be terribly picky about child tlist, but
 	 * we do need grouping columns to be available
 	 */
-	subplan = create_plan_recurse(root, best_path->subpath, CP_LABEL_TLIST);
+	subplan = create_plan_recurse(context, root, best_path->subpath, CP_LABEL_TLIST);
 
 	/*
 	 * Compute the mapping from tleSortGroupRef to column index in the child's
@@ -2533,6 +2725,7 @@ create_groupingsets_plan(PlannerInfo *root, GroupingSetsPath *best_path)
 
 		/* Copy cost data from Path to Plan */
 		copy_generic_path_info(&plan->plan, &best_path->path);
+		plan->plan.est_calls = clamp_row_est(context->est_calls);
 	}
 
 	return (Plan *) plan;
@@ -2545,7 +2738,8 @@ create_groupingsets_plan(PlannerInfo *root, GroupingSetsPath *best_path)
  *	  for its subpaths.
  */
 static Result *
-create_minmaxagg_plan(PlannerInfo *root, MinMaxAggPath *best_path)
+create_minmaxagg_plan(CreatePlanContext *context, PlannerInfo *root,
+					  MinMaxAggPath *best_path)
 {
 	Result	   *plan;
 	List	   *tlist;
@@ -2565,7 +2759,7 @@ create_minmaxagg_plan(PlannerInfo *root, MinMaxAggPath *best_path)
 		 * Since we are entering a different planner context (subroot),
 		 * recurse to create_plan not create_plan_recurse.
 		 */
-		plan = create_plan(subroot, mminfo->path);
+		plan = create_plan(context, subroot, mminfo->path);
 
 		plan = (Plan *) make_limit(plan,
 								   subparse->limitOffset,
@@ -2591,6 +2785,7 @@ create_minmaxagg_plan(PlannerInfo *root, MinMaxAggPath *best_path)
 	plan = make_result(tlist, (Node *) best_path->quals, NULL);
 
 	copy_generic_path_info(&plan->plan, (Path *) best_path);
+	plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	/*
 	 * During setrefs.c, we'll need to replace references to the Agg nodes
@@ -2611,7 +2806,8 @@ create_minmaxagg_plan(PlannerInfo *root, MinMaxAggPath *best_path)
  *	  for its subpaths.
  */
 static WindowAgg *
-create_windowagg_plan(PlannerInfo *root, WindowAggPath *best_path)
+create_windowagg_plan(CreatePlanContext *context, PlannerInfo *root,
+					  WindowAggPath *best_path)
 {
 	WindowAgg  *plan;
 	WindowClause *wc = best_path->winclause;
@@ -2635,7 +2831,7 @@ create_windowagg_plan(PlannerInfo *root, WindowAggPath *best_path)
 	 * behooves us to request a small tlist to avoid wasting space. We do of
 	 * course need grouping columns to be available.
 	 */
-	subplan = create_plan_recurse(root, best_path->subpath,
+	subplan = create_plan_recurse(context, root, best_path->subpath,
 								  CP_LABEL_TLIST | CP_SMALL_TLIST);
 
 	tlist = build_path_tlist(root, &best_path->path);
@@ -2703,6 +2899,7 @@ create_windowagg_plan(PlannerInfo *root, WindowAggPath *best_path)
 						  subplan);
 
 	copy_generic_path_info(&plan->plan, (Path *) best_path);
+	plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	return plan;
 }
@@ -2714,7 +2911,8 @@ create_windowagg_plan(PlannerInfo *root, WindowAggPath *best_path)
  *	  for its subpaths.
  */
 static SetOp *
-create_setop_plan(PlannerInfo *root, SetOpPath *best_path, int flags)
+create_setop_plan(CreatePlanContext *context, PlannerInfo *root,
+				  SetOpPath *best_path, int flags)
 {
 	SetOp	   *plan;
 	Plan	   *subplan;
@@ -2724,7 +2922,7 @@ create_setop_plan(PlannerInfo *root, SetOpPath *best_path, int flags)
 	 * SetOp doesn't project, so tlist requirements pass through; moreover we
 	 * need grouping columns to be labeled.
 	 */
-	subplan = create_plan_recurse(root, best_path->subpath,
+	subplan = create_plan_recurse(context, root, best_path->subpath,
 								  flags | CP_LABEL_TLIST);
 
 	/* Convert numGroups to long int --- but 'ware overflow! */
@@ -2739,6 +2937,7 @@ create_setop_plan(PlannerInfo *root, SetOpPath *best_path, int flags)
 					  numGroups);
 
 	copy_generic_path_info(&plan->plan, (Path *) best_path);
+	plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	return plan;
 }
@@ -2750,7 +2949,8 @@ create_setop_plan(PlannerInfo *root, SetOpPath *best_path, int flags)
  *	  for its subpaths.
  */
 static RecursiveUnion *
-create_recursiveunion_plan(PlannerInfo *root, RecursiveUnionPath *best_path)
+create_recursiveunion_plan(CreatePlanContext *context, PlannerInfo *root,
+						   RecursiveUnionPath *best_path)
 {
 	RecursiveUnion *plan;
 	Plan	   *leftplan;
@@ -2759,8 +2959,8 @@ create_recursiveunion_plan(PlannerInfo *root, RecursiveUnionPath *best_path)
 	long		numGroups;
 
 	/* Need both children to produce same tlist, so force it */
-	leftplan = create_plan_recurse(root, best_path->leftpath, CP_EXACT_TLIST);
-	rightplan = create_plan_recurse(root, best_path->rightpath, CP_EXACT_TLIST);
+	leftplan = create_plan_recurse(context, root, best_path->leftpath, CP_EXACT_TLIST);
+	rightplan = create_plan_recurse(context, root, best_path->rightpath, CP_EXACT_TLIST);
 
 	tlist = build_path_tlist(root, &best_path->path);
 
@@ -2775,6 +2975,7 @@ create_recursiveunion_plan(PlannerInfo *root, RecursiveUnionPath *best_path)
 								numGroups);
 
 	copy_generic_path_info(&plan->plan, (Path *) best_path);
+	plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	return plan;
 }
@@ -2786,18 +2987,19 @@ create_recursiveunion_plan(PlannerInfo *root, RecursiveUnionPath *best_path)
  *	  for its subpaths.
  */
 static LockRows *
-create_lockrows_plan(PlannerInfo *root, LockRowsPath *best_path,
-					 int flags)
+create_lockrows_plan(CreatePlanContext *context, PlannerInfo *root,
+					 LockRowsPath *best_path, int flags)
 {
 	LockRows   *plan;
 	Plan	   *subplan;
 
 	/* LockRows doesn't project, so tlist requirements pass through */
-	subplan = create_plan_recurse(root, best_path->subpath, flags);
+	subplan = create_plan_recurse(context, root, best_path->subpath, flags);
 
 	plan = make_lockrows(subplan, best_path->rowMarks, best_path->epqParam);
 
 	copy_generic_path_info(&plan->plan, (Path *) best_path);
+	plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	return plan;
 }
@@ -2809,14 +3011,15 @@ create_lockrows_plan(PlannerInfo *root, LockRowsPath *best_path,
  *	  Returns a Plan node.
  */
 static ModifyTable *
-create_modifytable_plan(PlannerInfo *root, ModifyTablePath *best_path)
+create_modifytable_plan(CreatePlanContext *context, PlannerInfo *root,
+						ModifyTablePath *best_path)
 {
 	ModifyTable *plan;
 	Path	   *subpath = best_path->subpath;
 	Plan	   *subplan;
 
 	/* Subplan must produce exactly the specified tlist */
-	subplan = create_plan_recurse(root, subpath, CP_EXACT_TLIST);
+	subplan = create_plan_recurse(context, root, subpath, CP_EXACT_TLIST);
 
 	/* Transfer resname/resjunk labeling, too, to keep executor happy */
 	apply_tlist_labeling(subplan->targetlist, root->processed_tlist);
@@ -2838,6 +3041,7 @@ create_modifytable_plan(PlannerInfo *root, ModifyTablePath *best_path)
 							best_path->epqParam);
 
 	copy_generic_path_info(&plan->plan, &best_path->path);
+	plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	return plan;
 }
@@ -2849,7 +3053,8 @@ create_modifytable_plan(PlannerInfo *root, ModifyTablePath *best_path)
  *	  for its subpaths.
  */
 static Limit *
-create_limit_plan(PlannerInfo *root, LimitPath *best_path, int flags)
+create_limit_plan(CreatePlanContext *context, PlannerInfo *root,
+				  LimitPath *best_path, int flags)
 {
 	Limit	   *plan;
 	Plan	   *subplan;
@@ -2859,7 +3064,7 @@ create_limit_plan(PlannerInfo *root, LimitPath *best_path, int flags)
 	Oid		   *uniqCollations = NULL;
 
 	/* Limit doesn't project, so tlist requirements pass through */
-	subplan = create_plan_recurse(root, best_path->subpath, flags);
+	subplan = create_plan_recurse(context, root, best_path->subpath, flags);
 
 	/* Extract information necessary for comparing rows for WITH TIES. */
 	if (best_path->limitOption == LIMIT_OPTION_WITH_TIES)
@@ -2892,6 +3097,7 @@ create_limit_plan(PlannerInfo *root, LimitPath *best_path, int flags)
 					  numUniqkeys, uniqColIdx, uniqOperators, uniqCollations);
 
 	copy_generic_path_info(&plan->plan, (Path *) best_path);
+	plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	return plan;
 }
@@ -2910,8 +3116,8 @@ create_limit_plan(PlannerInfo *root, LimitPath *best_path, int flags)
  *	 with restriction clauses 'scan_clauses' and targetlist 'tlist'.
  */
 static SeqScan *
-create_seqscan_plan(PlannerInfo *root, Path *best_path,
-					List *tlist, List *scan_clauses)
+create_seqscan_plan(CreatePlanContext *context, PlannerInfo *root,
+					Path *best_path, List *tlist, List *scan_clauses)
 {
 	SeqScan    *scan_plan;
 	Index		scan_relid = best_path->parent->relid;
@@ -2938,6 +3144,7 @@ create_seqscan_plan(PlannerInfo *root, Path *best_path,
 							 scan_relid);
 
 	copy_generic_path_info(&scan_plan->scan.plan, best_path);
+	scan_plan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
@@ -2948,8 +3155,8 @@ create_seqscan_plan(PlannerInfo *root, Path *best_path,
  *	 with restriction clauses 'scan_clauses' and targetlist 'tlist'.
  */
 static SampleScan *
-create_samplescan_plan(PlannerInfo *root, Path *best_path,
-					   List *tlist, List *scan_clauses)
+create_samplescan_plan(CreatePlanContext *context, PlannerInfo *root,
+					   Path *best_path, List *tlist, List *scan_clauses)
 {
 	SampleScan *scan_plan;
 	Index		scan_relid = best_path->parent->relid;
@@ -2984,6 +3191,7 @@ create_samplescan_plan(PlannerInfo *root, Path *best_path,
 								tsc);
 
 	copy_generic_path_info(&scan_plan->scan.plan, best_path);
+	scan_plan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
@@ -2999,7 +3207,8 @@ create_samplescan_plan(PlannerInfo *root, Path *best_path,
  * create_bitmap_subplan needs to be able to override the prior decision.
  */
 static Scan *
-create_indexscan_plan(PlannerInfo *root,
+create_indexscan_plan(CreatePlanContext *context,
+					  PlannerInfo *root,
 					  IndexPath *best_path,
 					  List *tlist,
 					  List *scan_clauses,
@@ -3185,6 +3394,7 @@ create_indexscan_plan(PlannerInfo *root,
 											best_path->indexscandir);
 
 	copy_generic_path_info(&scan_plan->plan, &best_path->path);
+	scan_plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
@@ -3195,7 +3405,8 @@ create_indexscan_plan(PlannerInfo *root,
  *	  with restriction clauses 'scan_clauses' and targetlist 'tlist'.
  */
 static BitmapHeapScan *
-create_bitmap_scan_plan(PlannerInfo *root,
+create_bitmap_scan_plan(CreatePlanContext *context,
+						PlannerInfo *root,
 						BitmapHeapPath *best_path,
 						List *tlist,
 						List *scan_clauses)
@@ -3214,7 +3425,7 @@ create_bitmap_scan_plan(PlannerInfo *root,
 	Assert(best_path->path.parent->rtekind == RTE_RELATION);
 
 	/* Process the bitmapqual tree into a Plan tree and qual lists */
-	bitmapqualplan = create_bitmap_subplan(root, best_path->bitmapqual,
+	bitmapqualplan = create_bitmap_subplan(context, root, best_path->bitmapqual,
 										   &bitmapqualorig, &indexquals,
 										   &indexECs);
 
@@ -3300,6 +3511,7 @@ create_bitmap_scan_plan(PlannerInfo *root,
 									 baserelid);
 
 	copy_generic_path_info(&scan_plan->scan.plan, &best_path->path);
+	scan_plan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
